!
!     CalculiX - A 3-dimensional finite element program
!              Copyright (C) 1998-2015 Guido Dhondt
!
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
      subroutine mafillv3(adv,auv6,bv,auv3,bv3,ielblk,
     &  ipnei,neiel,vel,nef,nefa,nefb,adv6,vela,velaa)
!
!     CFD block velocity equations: zeta direction
!
      implicit none
!
      integer i,k,nefa,nefb,ielblk(*),ipnei(*),neiel(*),nef,iblk,iel,
     &  indexf
!
      real*8 adv(*),auv6(6,*),bv(3,nef),auv3(3,*),bv3(3,nef),
     &  vel(nef,0:5),adv6(6,*),vela(nef,0:5),velaa(nef,0:5)
!
      intent(in) adv,auv6,bv,ielblk,ipnei,neiel,vel,nef,nefa,nefb
!
      intent(inout) auv3,bv3
!
      do i=nefa,nefb
!
         indexf=ipnei(i)
         iblk=ielblk(i)
!
         auv3(2,i)=adv(i)
         do k=1,3
            bv3(k,i)=bv(k,i)
         enddo
!
!        -ze
!
         indexf=ipnei(i)+1
         iel=neiel(indexf)
         if(iel.eq.0) then
            continue
         elseif(ielblk(iel).ne.iblk) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(1,i)*vel(iel,k)
     &                          -adv6(1,i)*vel(i,k)
            enddo
         else
            auv3(1,i)=auv6(1,i)/2.d0
            auv3(2,i)=auv3(2,i)+adv6(1,i)/2.d0
            do k=1,3
               bv3(k,i)=bv3(k,i)-(auv6(1,i)*vel(iel,k)
     &                           +adv6(1,i)*vel(i,k))/2.d0
            enddo
         endif
!
!        +ze
!
         indexf=ipnei(i)+2
         iel=neiel(indexf)
         if(iel.eq.0) then
            continue
         elseif(ielblk(iel).ne.iblk) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(2,i)*vel(iel,k)
     &                          -adv6(2,i)*vel(i,k)
            enddo
         else
            auv3(1,i)=auv6(2,i)/2.d0
            auv3(2,i)=auv3(2,i)+adv6(2,i)/2.d0
            do k=1,3
               bv3(k,i)=bv3(k,i)-(auv6(2,i)*vel(iel,k)
     &                           +adv6(2,i)*vel(i,k))/2.d0
            enddo
         endif
!
!        -et
!
         indexf=ipnei(i)+3
         iel=neiel(indexf)
         if(iel.ne.0) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(3,i)*velaa(iel,k)
     &                          -adv6(3,i)*velaa(i,k)
            enddo
         endif
!
!        +xi
!
         indexf=ipnei(i)+4
         iel=neiel(indexf)
         if(iel.ne.0) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(4,i)*vela(iel,k)
     &                          -adv6(4,i)*vela(i,k)
            enddo
         endif
!
!        +et
!
         indexf=ipnei(i)+5
         iel=neiel(indexf)
         if(iel.ne.0) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(5,i)*velaa(iel,k)
     &                          -adv6(5,i)*velaa(i,k)
            enddo
         endif
!
!        -xi
!
         indexf=ipnei(i)+6
         iel=neiel(indexf)
         if(iel.ne.0) then
            do k=1,3
               bv3(k,i)=bv3(k,i)-auv6(6,i)*vela(iel,k)
     &                          -adv6(6,i)*vela(i,k)
            enddo
         endif
!
      enddo
!     
      return
      end
